/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>
#include <clocale>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, i, j;
vector <int> v, a;
vector <int> otv;
long long k, t;
long long m = 1000000000;
vector <bool> flag;

int gcd(int a, int b)
{
    while(b > 0)
    {
        a = a % b;
        swap(a, b);
    }

    return a;
}

int main()
{
    freopen("sleep.in", "r", stdin);
    freopen("sleep.out", "w", stdout);

    scanf("%d", &n);
    for(i = 0; i < n; i++)
    {
        scanf("%d", &j);
        a.push_back(j - 1);
    }

    flag.resize(n, false);
    for(i = 0; i < n; i++)
        if(flag[i] == false)
        {
            t = 1;
            j = i;
            flag[j] = true;

            while(a[j] != i)
            {
                t++;
                j = a[j];
                flag[j] = true;
            }

            v.push_back(t);
        }

    n = v.size();
    otv.push_back(1);
    for(i = 0; i < n; i++)
        if(v[i] != 1)
        {
            t = 0;
            for(j = 0; j < otv.size(); j++)
            {
                k = otv[j];
                otv[j] = (k * v[i] + t) % m;
                t = (k * v[i] + t) / m;
            }
            if(t > 0)
                otv.push_back(t);

            for(j = i + 1; j < n; j++)
                if(v[j] != 1)
                    v[j] = v[j] / gcd(v[i], v[j]);
        }

    printf("%d", otv[otv.size() - 1]);
    if(otv.size() > 1)
        for(i = otv.size() - 2; i >= 0; i--)
            printf("%09d", otv[i]);
    printf("\n");

    return 0;
}

